<script setup lang="ts">
import * as api from '../api';
import * as util from '../util';
import { computed, ref, defineEmits } from 'vue';
import { Group, Invitation } from '../entities';
import { it } from 'node:test';
import { VForm } from 'vuetify/lib';

const props = defineProps<{
  invitation: Invitation;
  action: 'create' | 'repeat' | 'delete';
  showPermissions: boolean;
  groups: Group[];
}>();
const emit = defineEmits(['done', 'cancel']);
const form = ref<typeof VForm | null>(null);
const visible = computed(() => props.invitation !== undefined);
const title = computed<string>(() => {
  let result = '';

  switch (props.action) {
    case 'create':
      result = 'erstellen';
      break;
    case 'repeat':
      result = 'wiederholen';
      break;
    case 'delete':
      result = 'löschen';
      break;
  }

  return result;
});
const successMessage = computed<string>(() => {
  let result = '';

  switch (props.action) {
    case 'create':
      result = 'versendet';
      break;
    case 'repeat':
      result = 'wiederholt';
      break;
    case 'delete':
      result = 'gelöscht';
      break;
  }

  return result;
});
const loading = ref(false);
const snackbar = ref<{
  show: boolean;
  message: string;
  details: string[];
}>({
  show: false,
  message: '',
  details: [],
});
const success = ref(false);
const invitablePermissions = ref(['INVITE']);
const disabled = computed(() => loading.value || props.action != 'create');
const workingCopy = ref({ ...props.invitation });
const error: string[] = [];
const selectableGroups = computed(() =>
  [
    ...props.groups.map((it) => ({ ...it, nameAndDescription: `${it.name} (${it.description})` })),
  ].sort()
);

function doAction() {
  snackbar.value = {
    details: [],
    message: '',
    show: false,
  };

  if (form.value && form.value.validate()) {
    loading.value = true;

    let apiCall: Promise<'success' | 'not_found' | 'no_permission' | string[] | Invitation>;

    switch (props.action) {
      case 'repeat': {
        apiCall = api.invitation.repeatInvitation(props.invitation);
        break;
      }
      case 'delete': {
        apiCall = api.invitation.withdrawInvitation(props.invitation);
        break;
      }
      case 'create': {
        apiCall = api.invitation.createInvitation(
          workingCopy.value.invitee.firstname,
          workingCopy.value.invitee.surname,
          workingCopy.value.invitee.mail,
          workingCopy.value.invitee.groups.map((it) => Number(it)),
          workingCopy.value.invitee.permissions
        );
        break;
      }
    }

    api.allCatching([apiCall]).finally(() => (loading.value = false));

    apiCall.then((result) => {
      if (result === 'not_found') {
        snackbar.value.message = 'Die Einladung konnte nicht gefunden werden';
        snackbar.value.show = true;
      } else if (result === 'no_permission') {
        snackbar.value.message = 'Es besteht keine Berechtigung für diese Einladung';
        snackbar.value.show = true;
      } else if (Array.isArray(result)) {
        snackbar.value.message = 'Es sind folgende Fehler aufgetreten:';
        snackbar.value.details = result;
        snackbar.value.show = true;
      } else {
        success.value = true;
        snackbar.value.message = 'Einladung erfolgreich ' + successMessage.value;
        snackbar.value.show = true;

        new Promise((r) => setTimeout(r, 1500)).then(() => {
          success.value = false;
          snackbar.value = {
            details: [],
            message: '',
            show: false,
          };
          emit('done');
        });
      }
    });
  }
}

const checkBoxRule: (arg0: boolean) => string | boolean = (checked) => {
  return checked ? true : false;
};
</script>

<template>
  <div>
    <v-snackbar
      v-model="snackbar.show"
      :color="success ? 'success' : 'error'"
      top
      multi-line
      vertical
    >
      <div>
        {{ snackbar.message }}
        <ul v-id="snackbar.details.length > 0" v-for="detail in snackbar.details">
          <li>{{ detail }}</li>
        </ul>
      </div>
    </v-snackbar>
    <v-dialog v-model="visible" persistent width="70%" min-width="800px">
      <v-card :loading="loading">
        <v-card-title> Einladung {{ title }}</v-card-title>
        <v-card-text>
          <v-form ref="form">
            <v-alert type="warning" v-if="error.length > 0">
              Bitte folgende Fehler beheben:
              <ul>
                <li v-for="e in error" :key="e">
                  {{ e }}
                </li>
              </ul>
            </v-alert>

            <v-row>
              <v-col>
                <v-text-field
                  label="Vorname"
                  prepend-icon="mdi-account-box"
                  v-model="workingCopy.invitee.firstname"
                  :rules="[util.validateName]"
                  :disabled="disabled"
                />
              </v-col>
              <v-col>
                <v-text-field
                  label="Nachname"
                  prepend-icon="mdi-account-box-outline"
                  v-model="workingCopy.invitee.surname"
                  :rules="[util.validateName]"
                  :disabled="disabled"
                />
              </v-col>
            </v-row>

            <v-text-field
              label="E-Mail"
              prepend-icon="mdi-email"
              v-model="workingCopy.invitee.mail"
              :rules="[util.validateMail]"
              :disabled="disabled"
            />

            <v-checkbox
              :rules="[checkBoxRule]"
              :disabled="disabled"
              required
              v-if="props.action === 'create'"
            >
              <template v-slot:label>
                Ich habe die Identität der Person mithilfe eines Ausweisdokuments überprüft oder
                kenne ihn oder sie persönlich.
              </template>
            </v-checkbox>

            <v-autocomplete
              v-model="workingCopy.invitee.groups"
              :items="selectableGroups"
              item-text="nameAndDescription"
              item-value="id"
              label="Gruppenzugehörigkeit"
              multiple
              chips
              prepend-icon="mdi-account-multiple"
              :disabled="disabled"
            ></v-autocomplete>

            <v-autocomplete
              v-if="showPermissions"
              v-model="workingCopy.invitee.permissions"
              :items="invitablePermissions"
              multiple
              chips
              item-text="value"
              item-value="id"
              prepend-icon="mdi-account-check-outline"
              label="Rechte"
              :disabled="disabled"
            >
            </v-autocomplete>

            <v-checkbox
              :rules="[checkBoxRule]"
              :disabled="disabled"
              required
              v-if="props.action === 'create'"
            >
              <template v-slot:label>
                <div>
                  <span
                    >Ich habe die einzuladende Person darüber aufgeklärt, dass mit der Einladung ihr
                    Name und ihr E-Mail-Addresse in unserem System verwaltet werden. Der/Die
                    Eingeladene muss bei der Registrierung der Datenschutzerklärung zustimmen, um
                    die Anmeldung abzuschließen. Andernfalls verliert die Einladung nach 30 Tagen
                    ihre Gültigkeit und die Daten werden wieder gelöscht.</span
                  >
                </div>
              </template>
            </v-checkbox>
          </v-form>
        </v-card-text>
        <v-card-actions v-if="!success">
          <v-btn
            :color="util.CONFIG.MAIN_BAR_COLOR"
            tile
            @click="$emit('cancel')"
            :disabled="loading"
          >
            Abbrechen
          </v-btn>
          <v-spacer></v-spacer>
          <v-btn :color="util.CONFIG.MAIN_BAR_COLOR" tile @click="doAction" :disabled="loading">
            {{ title }}
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>
